'Bascom Alarmanlage

$regfile = "m88def.dat"
$crystal = 8000000

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

'Timer und der Teiler festlegen 10ms
Config Timer0 = Timer , Prescale = 1024
On Timer0 Timer_irq
Const Timervorgabe = 215
Enable Timer0
Enable Interrupts


Ldr Alias Getadc(0)
Poti Alias Getadc(7)

Flash Alias Portb.6
Config Flash = Output
Flash = 0

Buzzer Alias Portb.0
Config Buzzer = Output


Declare Sub Alarm()


Dim Sirene As Byte
Dim Sensor_adj As Word
Dim Sensor_low As Word
Dim Sensor_high As Word
Dim X As Byte
Dim Cnt As Byte
Dim Sekunde As Byte
Dim Empfindlichkeit As Word


Enable Interrupts


Sensor_adj = Ldr
Wait 1

Do

   Empfindlichkeit = Poti + 1
   Empfindlichkeit = Empfindlichkeit / 32
   Sensor_low = Sensor_adj - Empfindlichkeit
   Sensor_high = Sensor_adj + Empfindlichkeit


   If Ldr < Sensor_low Or Ldr > Sensor_high Then

      Alarm

   End If



Loop


Sub Alarm()

   For Sirene = 0 To 3

     For X = 160 To 120 Step -1
     Sound Buzzer , 20 , X
     Next

     For X = 120 To 160
     Sound Buzzer , 20 , X
     Next

   Next

End Sub


Timer_irq:
Timer0 = Timervorgabe

   Incr Cnt

   'Sekunde hochzhlen
   If Cnt => 100 Then
      Toggle Portb.6
      Incr Sekunde
      Cnt = 0
   End If

   If Sekunde > 60 Then
      Sensor_adj = Ldr
      Sekunde = 0
   End If

Return
End