'Bascom Counter

$regfile = "m88def.dat"
$crystal = 8000000
$baud = 19200

Config Int0 = Falling

Config Timer1 = Timer , Prescale = 256
Const Timervorgabe = 3036
Const Markierungenproscheibe = 120
Dim Zaehlerirq0 As Long
Dim Impulseprosekunde As Long
Dim Impulseprominute As Long
Dim Umdrehungenprominute As Integer

Print
Print "Drehzahl mit Timer1 ermitteln"
Print 

Zaehlerirq0 = 0
On Int0 Irq0
Enable Int0

On Timer1 Timer_irq
Enable Timer1
Enable Interrupts

Do
   Print
   Print "Impulse Sek: " ; Impulseprosekunde
   Impulseprominute = Impulseprosekunde * 60
   Umdrehungenprominute = Impulseprominute / Markierungenproscheibe
   Print "Umdreh. Min: " ; Umdrehungenprominute
   Wait 3
Loop

End

'Pro Impuls (Markierung auf Scheibe) ein Aufruf
Irq0:
 Incr Zaehlerirq0
Return

'Pro Sekunde ein Aufruf
Timer_irq:
  Timer1 = Timervorgabe
  Impulseprosekunde = Zaehlerirq0
  Zaehlerirq0 = 0
Return