'GPS Daten einlesen
'umwandeln in und ber USB ausgeben

$regfile = "m88def.dat"
$crystal = 8000000
$baud = 19200

Open "comd.4:4800,8,n,1" For Input As #2

Dim Code As Word
Dim A As Byte
Dim Datenstrom As String * 80
Dim Block As String * 6

Dim Stunde As String * 2
Dim Minute As String * 2
Dim Sekunde As String * 2

Dim Latgrad As String * 2
Dim Latmin As String * 2
Dim Latsec As String * 4
Dim Latpol As String * 1

Dim Longrad As String * 3
Dim Lonmin As String * 2
Dim Lonsec As String * 4
Dim Lonpol As String * 1

Dim Signal As String * 1
Dim Signal_out As String * 10
Dim Sat As String * 2
Dim Hohe As String * 3

Dim Bearing As String * 3
Dim Speed As String * 4
Dim Suche As Byte
Dim Laenge As Byte

Print Chr(&H1b) ; "[1;1H";                                  'Home
Print Chr(&H1b) ; "[2J";                                    'clear terminal screen


Do

    Do
    A = Inkey(#2)
    If A = "$" Then Input #2 , Datenstrom
    Block = Mid(datenstrom , 1 , 6)
    Loop Until Block = "GPGGA,"

    'GPS UTC
    Suche = Instr(datenstrom , "," )
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Stunde = Mid(datenstrom , 1 , 2)
    Minute = Mid(datenstrom , 3 , 2)
    Sekunde = Mid(datenstrom , 5 , 2)

    'Latitude
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Latgrad = Mid(datenstrom , 1 , 2)
    Latmin = Mid(datenstrom , 3 , 2)
    Latsec = Mid(datenstrom , 6 , 4)

    'Nord oder Sd
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Latpol = Mid(datenstrom , 1 , 1)

    'Longitude
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Longrad = Mid(datenstrom , 1 , 3)
    Lonmin = Mid(datenstrom , 4 , 2)
    Lonsec = Mid(datenstrom , 7 , 4)

    'West oder Ost
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Lonpol = Mid(datenstrom , 1 , 1)

    'Signalqualitt
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Signal = Mid(datenstrom , 1 , 1)

    Select Case Signal

     Case "0" : Signal_out = "Fehler    "
     Case "1" : Signal_out = "GPS       "
     Case "2" : Signal_out = "DGPS      "
     Case "6" : Signal_out = "Geschaetzt"

    Case Else : Signal_out = "---      "

    End Select

    'Sat
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Sat = Mid(datenstrom , 1 , 2)

    'Hhe ber Geoid
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Hohe = Mid(datenstrom , 1 , 3)

    'GPVTG abfangen
    Do
    A = Inkey(#2)
    If A = "$" Then Input #2 , Datenstrom
    Block = Mid(datenstrom , 1 , 6)
    Loop Until Block = "GPVTG,"

    'Kompass
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Laenge = Instr(datenstrom , ".")
    If Laenge = 0 Then Laenge = 4
    If Laenge = 2 Then Laenge = 1
    If Laenge = 3 Then Laenge = 2
    If Laenge > 3 Then Laenge = 3
    Bearing = Mid(datenstrom , 1 , Laenge)
    If Bearing = ",T," Then Bearing = "---"

    'Speed
    Suche = Instr(datenstrom , "," )
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Suche = Instr(datenstrom , "," )
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Suche = Instr(datenstrom , ",")
    Suche = Suche + 1
    Datenstrom = Mid(datenstrom , Suche)
    Laenge = Instr(datenstrom , ",")
    If Laenge = 1 Then Laenge = 5
    If Laenge > 3 Then Laenge = Laenge - 1
    Speed = Mid(datenstrom , 1 , Laenge)
    If Speed = ",K*4" Then Speed = "---"

    'Ausgabe (Terminal auf VT100 Simulation)
    Print Chr(&H1b) ; "[1;1H";

    Print "GPS - Monitor  "
    Print "==============="
    Print "$GPGGA + $GPVTG"
    Print "V1.0 - 2009 US "
    Print "---------------"
    Print

    Print "UTC: " ; Stunde ; ":" ; Minute ; ":" ; Sekunde
    Print "LAT: " ; Latgrad ; "." ; Latmin ; "'" ; Latsec ; Latpol
    Print "LON: " ; Longrad ; "." ; Lonmin ; "'" ; Lonsec ; Lonpol
    Print "Richtung: " ; Bearing ; " Grad   "
    Print "Satelliten: " ; Sat
    Print "Speed: " ; Speed ; " Km/h   "
    Print "Hoehe: " ; Hohe ; " Meter   "
    Print "Signal: " ; Signal_out

Loop
End