'Bascom Lftersteuerung

$regfile = "m88def.dat"
$crystal = 8000000

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

'Timer und der Teiler festlegen 10ms
Config Timer0 = Timer , Prescale = 1024
On Timer0 Timer_irq
Const Timervorgabe = 175
Enable Timer0
Enable Interrupts


Ldr Alias Getadc(0)
Poti Alias Getadc(7)

Luefter Alias Portb.6
Config Luefter = Output

Dim Cnt As Byte
Dim Sekunde As Byte
Dim Minute As Byte
Dim Flag As Bit

Const Zeit_on_minute = 1
Const On_delay_sekunde = 30

Enable Interrupts
Flag = 0

Do

     If Ldr < Poti And Flag = 0 Then

        Cnt = 0
        Sekunde = 0
        Minute = 0
        Flag = 1

      Elseif Ldr > Poti And Flag = 1 Then

        Flag = 0

      End If


     If Sekunde > On_delay_sekunde Then
        If Ldr < Poti Then

           Luefter = 1

           Do
           Loop Until Ldr > Poti

           Cnt = 0
           Sekunde = 0
           Minute = 0

           Do
           Loop Until Minute > Zeit_on_minute

           Luefter = 0
           Flag = 0
           Cnt = 0
           Sekunde = 0
           Minute = 0

        Else

           Flag = 0

        End If
     End If

Loop


Timer_irq:
Timer0 = Timervorgabe

   Incr Cnt

   'Sekunde hochzhlen
   If Cnt = 100 Then
      Incr Sekunde
      Cnt = 0
      If Sekunde = 60 Then
         Incr Minute
         Sekunde = 0
      End If
   End If

Return
End
