'Bascom Min / Max Temperatur Messung mit LM335

$regfile = "m88def.dat"
$crystal = 8000000
$baud = 19200

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

Dim Raw As Word
Dim Raw_last As Word
Dim Grad As Single
Dim Fahrenheit As Single
Dim Grad_str As String * 4
Dim Fahrenheit_str As String * 4
Dim Mittel(40) As Word
Dim Mittel_sum As Word
Dim X As Byte
Dim Raw_min As Word
Dim Raw_max As Word
Dim Grad_min As Single
Dim Grad_max As Single
Dim Min_str As String * 4
Dim Max_str As String * 4

Declare Function Calc_g(byval A As Word) As Single
Declare Function Calc_f(byval A As Single) As Single


Raw_min = 999

Do

      'Mittelwertbildung
      For X = 1 To 40
         Mittel(x) = Getadc(0)
         Waitms 50
      Next

      For X = 1 To 40
          Mittel_sum = Mittel_sum + Mittel(x)
      Next

      Raw = Mittel_sum / 40
      Mittel_sum = 0

      If Raw_max < Raw Then Raw_max = Raw
      If Raw_min > Raw Then Raw_min = Raw


      Grad = Calc_g(raw)
      Grad_str = Fusing(grad , "#.#")
      Print "Temp: " ; Grad_str ; " C"


      Fahrenheit = Calc_f(grad)
      Fahrenheit_str = Fusing(fahrenheit , "#.#")
      Print "Temp: " ; Fahrenheit_str ; " F"


      Grad_min = Calc_g(raw_min)
      Min_str = Fusing(grad_min , "#.#")
      Print "MIN: " ; Min_str ; " C"


      Grad_max = Calc_g(raw_max)
      Max_str = Fusing(grad_max , "#.#")
      Print "MAX: " ; Max_str ; " C"
      Print

      Wait 1


Loop


Function Calc_g(byval A As Word) As Single

      'Temperature in Grad = ((ADReading x Avcc) / 1024) x 100) - 273.15
      'Temperature in Fahrenheit = Temperature x 1.8 + 32

      Local G As Single
      G = A * 4.68                                          'Ub Messen und hier eintragen!
      G = G / 1024
      G = G * 100
      Calc_g = G - 273.15

End Function


Function Calc_f(byval A As Single) As Single

      Local F As Single
      F = A * 1.8
      Calc_f = F + 32

End Function

End