'Bascom Morsecode Generator

$regfile = "m88def.dat"
$crystal = 8000000
$baud = 19200


Buzzer Alias Portb.0
Config Buzzer = Output


Dim X As Byte
Dim Y As Byte
Dim M_code As String * 81
Dim Str_split(81) As String * 1
Dim Str_len As Byte
Dim Morsecode As String * 1
Dim Morsecode_ascii_val As Byte
Dim Code As String * 10
Dim Code_len As Byte
Dim Code_tab(255) As String * 1
Dim Dit As Word
Dim Dah As Word
Dim Pause As Word
Dim Speed As Byte


Enable Interrupts

'bertragungsrate in WPM  Lnge eines Dits
'1   WPM = 1200 ms
'5   WPM = 240 ms
'10  WPM = 120 ms
'20  WPM = 60 ms

Main:

   Input "Speed eingeben 1 bis 20WPM: " , Speed

   Dit = 1200 / Speed
   Dah = Dit * 3
   Pause = Dah

Do

  Input "Text eingeben: " , M_code

  Str_len = Split(m_code , Str_split(1) , " ")

  If Str_len > 80 Then
     Print "Text ist zu lang, max. 80 Zeichen!"
     Goto Main
   End If


  Str_len = Str_len - 1
  For X = 1 To Str_len
      Morsecode = Ucase(str_split(x))

      If Morsecode = " " Then Waitms Pause

      Morsecode_ascii_val = Asc(morsecode)

      Morsecode_ascii_val = Morsecode_ascii_val - 35

      Code = Lookupstr(morsecode_ascii_val , Morsealfabet)  'code aus tabelle holen
      Code_len = Split(code , Code_tab(1) , " ")            'wie lang is der code

      Code_len = Code_len - 1
      For Y = 1 To Code_len

          If Code_tab(y) = "." Then
             Sound Buzzer , Dit , 240
             Waitms Dit
          End If

          If Code_tab(y) = "-" Then
             Sound Buzzer , Dah , 240
             Waitms Dit
          End If

      Next

  Next

Loop
End



Morsealfabet:
Data "........."                                            '#
Data "........."                                            '$
Data "........."                                            '%
Data "........."                                            '&
Data ".----."                                               ' '
Data "-.--."                                                ' (
Data "-.--.-"                                               ')
Data "........."                                            '*
Data "........."                                            '+
Data "--..--"                                               ',
Data "-...._"                                               '-
Data ".-.-.-"                                               '.
Data "-..-."                                                '/
Data "-----"                                                '0
Data ".----"                                                '1
Data "..---"                                                '2
Data "...--"                                                '3
Data "....-"                                                '4
Data "....."                                                '5
Data "-...."                                                '6
Data "--..."                                                '7
Data "---.."                                                '8
Data "----."                                                '9
Data "---..."                                               ':
Data "........."                                            ';
Data "........."                                            '<
Data "........."                                            '=
Data "........."                                            '>
Data "..--.."                                               '?
Data "........."                                            '@
Data ".-"                                                   'A
Data "-..."                                                 'B
Data "-.-."                                                 'C
Data "-.."                                                  'D
Data "."                                                    'E
Data "..-."                                                 'F
Data "--."                                                  'G
Data "...."                                                 'H
Data ".."                                                   'I
Data ".---"                                                 'J
Data "-.-"                                                  'K
Data ".-.."                                                 'L
Data "--"                                                   'M
Data "-."                                                   'N
Data "---"                                                  'O
Data ".--."                                                 'P
Data "--.-"                                                 'Q
Data ".-."                                                  'R
Data "..."                                                  'S
Data "-"                                                    'T
Data "..-"                                                  'U
Data "...-"                                                 'V
Data ".--"                                                  'W
Data "-..-"                                                 'X
Data "-.--"                                                 'Y
Data "--.."                                                 'Z