'Bascom Schulklingelsteuerung

$regfile = "m88def.dat"
$crystal = 8000000
$baud = 19200

Buzzer Alias Portb.0
Config Buzzer = Output
Config Portb.6 = Output
Config Portb.7 = Output
Portb.6 = 0
Portb.7 = 0

'Timer und der Teiler festlegen 10ms
Config Timer0 = Timer , Prescale = 1024
On Timer0 Timer_irq
Const Timervorgabe = 175
Enable Interrupts


Dim Cnt As Byte
Dim Sekunde As Byte
Dim Minute As Byte
Dim Stunde As Byte
Dim Sekunde_last As Byte

Input "Stunde eingeben: " , Stunde
Input "Minute eingeben: " , Minute
Sekunde = 0
Enable Timer0

Do

      Idle

      ' 1. Stunde
        If Stunde = 7 And Minute = 0 Then Gosub Bell
        If Stunde = 7 And Minute = 45 Then Gosub Bell

      ' 2. Stunde
        If Stunde = 7 And Minute = 55 Then Gosub Bell
        If Stunde = 8 And Minute = 40 Then Gosub Bell

      ' Frhstueckspause

      ' 3. Stunde
        If Stunde = 9 And Minute = 0 Then Gosub Bell
        If Stunde = 9 And Minute = 45 Then Gosub Bell

      ' 4. Stunde
        If Stunde = 9 And Minute = 55 Then Gosub Bell
        If Stunde = 10 And Minute = 40 Then Gosub Bell

      ' 5. Stunde
        If Stunde = 10 And Minute = 50 Then Gosub Bell
        If Stunde = 11 And Minute = 35 Then Gosub Bell

      ' Mittagspause

      ' 6. Stunde
        If Stunde = 12 And Minute = 05 Then Gosub Bell
        If Stunde = 12 And Minute = 50 Then Gosub Bell

      ' 7. Stunde
        If Stunde = 13 And Minute = 0 Then Gosub Bell
        If Stunde = 13 And Minute = 45 Then Gosub Bell

        Gosub Show_time

Loop


'Luten
Bell:
    If Sekunde < 10 Then
      Set Portb.7
      Do
      Idle
      Loop Until Sekunde < 10
    Else
      Reset Portb.7
    End If
Return


'Systemtimer aufrufen
Show_time:
  If Sekunde <> Sekunde_last Then
     Print Stunde ; ":" ; Minute ; ":" ; Sekunde
     Sekunde_last = Sekunde
  End If
Return


Timer_irq:
Timer0 = Timervorgabe

   Incr Cnt

    If Cnt = 50 Then
       portb.6 = 0
    End If

    If Cnt = 100 Then
       Portb.6 = 1
       Print Stunde ; ":" ; Minute ; ":" ; Sekunde
       Sekunde = Sekunde + 1
       If Sekunde = 60 Then
          Sekunde = 0
          Minute = Minute + 1
          If Minute = 60 Then
             Minute = 0
             Stunde = Stunde + 1
             If Stunde = 24 Then
                Stunde = 0
             End If
          End If
       End If
       Cnt = 0
    End If

Return
End