'Bascom Messen mit Stamp-Plot (light)
'ADC-Port mit Poti


$regfile = "m88def.dat"
$crystal = 8000000
$baud = 19200

Config Adc = Single , Prescaler = Auto , Reference = Avcc


Dim Adc0 As Word


Led_pb6 Alias Portb.6
Config Led_pb6 = Output
Reset Led_pb6

Wait 10


Main:

'Stampplot Einstellungen senden
Print "!RSET"                                               'Reset plot To clear data
Print "!TITL Bascom DEMO-PLOT"                              'Caption form
Print "!PNTS 1000"                                          '1000 sample data points
Print "!TMAX 60"                                            'Max 60 seconds
Print "!SPAN 0,1023"                                        '0-1023 Span
Print "!AMUL 1"                                             'Multiply data by 1
Print "!DELD"                                               'Delete Data File
Print "!SAVD ON"                                            'Save Data
Print "!TSMP ON"                                            'Time Stamp On
Print "!CLMM"                                               'Clear Min/Max
Print "!CLRM"                                               'Clear Messages
Print "!PLOT ON"                                            'Start Plotting
Print "!RSET"                                               'Reset plot To time 0


Do

   Adc0 = Getadc(7)
   Print Adc0 ; Chr(13)

   If Adc0 > 800 Then
      Print "!USRS P1 > 800!"
      Print "P1 ist grer 800"
      Set Led_pb6
   End If


   If Adc0 < 250 Then
      Print "!USRS P1 < 250!"
      Print "P1 ist kleiner 250"
      Reset Led_pb6
   End If

   Waitms 200

Loop