'Bascom Temperatur Messung mit LM335

$regfile = "m88def.dat"
$crystal = 8000000
$baud = 19200

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

Dim Raw As Word
Dim Raw_last As Word
Dim Grad As Single
Dim Fahrenheit As Single
Dim Grad_str As String * 4
Dim Fahrenheit_str As String * 4
Dim Mittel(40) As Word
Dim Mittel_sum As Word
Dim X As Byte

Do

      'Mittelwertbildung
      For X = 1 To 40
         Mittel(x) = Getadc(6)
         Waitms 50
      Next

      For X = 1 To 40
          Mittel_sum = Mittel_sum + Mittel(x)
      Next

      Raw = Mittel_sum / 40
      Mittel_sum = 0


      'Temperature in Grad = ((ADReading x Avcc) / 1024) x 100) - 273.15
      'Temperature in Fahrenheit = Temperature x 1.8 + 32

      Grad = Raw * 4.295                                     'Avcc Messen und hier eintragen!
      Grad = Grad / 1024
      Grad = Grad * 100
      Grad = Grad - 273.15

      Fahrenheit = Grad * 1.8
      Fahrenheit = Fahrenheit + 32

      Grad_str = Fusing(grad , "#.#")
      Print "Temp: " ; Grad_str ; " C"

      Fahrenheit_str = Fusing(fahrenheit , "#.#")
      Print "Temp: " ; Fahrenheit_str ; " F"
      Print

      Wait 1


Loop
End