'Bascom Codeschloss mit zwei Taster

$regfile = "m88def.dat"
$crystal = 8000000

Sw1 Alias Pind.2
Config Sw1 = Input
Portd.2 = 1

Sw2 Alias Pind.3
Config Sw2 = Input
Portd.3 = 1

Led1 Alias Portb.6
Config Led1 = Output
Led1 = 0

Led2 Alias Portb.7
Config Led2 = Output
Led2 = 0

Buzzer Alias Portb.0
Config Buzzer = Output


Dim X As Byte
Dim Y As Byte
Dim Code1 As Bit
Dim Code2 As Bit
Dim Reset_timer As Word

Enable Interrupts


Main:
Gosub Clr_code

Do

   'Code 1 = 5
   If Sw1 = 0 Then
      Waitms 50
      If Sw1 = 0 Then
         Gosub Blinken
         Incr X
         If X = 5 Then
            Code1 = 1
         Else
            Code1 = 0
         End If
         Do
         Waitms 50
         Loop Until Sw1 = 1
      End If
   End If


   'Code 2 = 3
   If Sw2 = 0 Then
      Waitms 50
      If Sw2 = 0 Then
         Gosub Blinken
         Incr Y
         If Y = 3 Then
            Code2 = 1
         Else
            Code2 = 0
         End If
         Do
         Waitms 50
         Incr Reset_timer
         'Taste lnger als 2,5Sek gedrckt = Reset
         If Reset_timer > 50 Then
            Gosub Toggle_flash
            Goto Main
         End If
         Loop Until Sw2 = 1
         Reset_timer = 0
      End If
   End If


   'Code OK?
   If Code1 = 1 Then
    If Code2 = 1 Then
      Set Led1
      Gosub Clr_code
      Wait 5
      Reset Led1
    Else
      Reset Led1
    End If
   End If


Loop
End


Blinken:
   Set Led2
   Sound Buzzer , 250 , 240
   Reset Led2
Return


Toggle_flash:
   For X = 1 To 6
   Toggle Led2
   Sound Buzzer , 250 , 240
   Waitms 100
   Next
Return


Clr_code:
   X = 0
   Y = 0
   Code1 = 0
   Code2 = 0
   Reset_timer = 0
   Wait 1
Return